#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$l0 = ();
$l1 = ();
$go = 0;



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-0"){
		$l0 = $ARGV[$k+1];
		$l0 =~ tr/[a-z][A-Z][0-9]-//cd;
		if(length($l0)){
			$go++;
			}
		}
	if($ARGV[$k] eq "-1"){
		$l1 = $ARGV[$k+1];
		$l1 =~ tr/[a-z][A-Z][0-9]-//cd;
		if(length($l1)){
			$go++;
			}
		}	
	}



if($go == 2){ ############################### INPUT GIVEN
	
	
	
	############################### DATABASE CONNECTION
	use DBI;
	my $database = "markers";
	my $host = "localhost";
	my $id = "realBOLD";
	my $password = "realBOLD";
	my $sql = DBI->connect("DBI:mysql:$database:$host",$id,$password);
	if(!defined $sql) { 
		die "Cannot connect: $DBI::errstr \n";
		}
		
		
		
	############################### ADD NEW LOCUS
	$query = "INSERT IGNORE INTO loci SET locus = ?, locusLong = ?";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute("$l0$l1", "$l0$l1") || die "cannot execute the query: $sth->errstr";
	
	
	
	############################### ADD NEW SEQUENCES
	$query = "CREATE TEMPORARY TABLE aaa
		  SELECT DISTINCT specimenID 
		  FROM ((SELECT sequences.specimenID FROM sequences, loci WHERE sequences.locusID = loci.locusID AND loci.locus = ?)
		       UNION
		       (SELECT sequences.specimenID FROM sequences, loci WHERE sequences.locusID = loci.locusID AND loci.locus = ?)) AS xxx";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l0, $l1) || die "cannot execute the query: $sth->errstr";
		       
	$query = "CREATE TEMPORARY TABLE bbb
		  SELECT sequences.sequenceID, sequences.specimenID, sequences.score
		  FROM sequences, loci 
		  WHERE sequences.locusID = loci.locusID AND loci.locus = ?";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l0) || die "cannot execute the query: $sth->errstr";	  

	$query = "CREATE TEMPORARY TABLE ccc
	          SELECT sequences.sequenceID, sequences.specimenID, sequences.score
		  FROM sequences, loci 
		  WHERE sequences.locusID = loci.locusID AND loci.locus = ?";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l1) || die "cannot execute the query: $sth->errstr";
	
	$query = "INSERT IGNORE INTO sequences (locusID, specimenID, score, sequence0ID, sequence1ID)
		  SELECT (SELECT loci.locusID FROM loci where loci.locus = ?) AS locusID, aaa.specimenID AS specimenID, (COALESCE(bbb.score,0) + COALESCE(ccc.score,0)) AS score, bbb.sequenceID AS sequence0ID, ccc.sequenceID AS sequence1ID
		  FROM aaa 
		  LEFT JOIN bbb ON (aaa.specimenID = bbb.specimenID)
		  LEFT JOIN ccc ON (aaa.specimenID = ccc.specimenID)";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute("$l0$l1") || die "cannot execute the query: $sth->errstr";
	
	
	
	############################### SELECT NEW SEQUENCES
	$query = "SELECT sequenceID, sequence0ID, sequence1ID FROM sequences, loci WHERE sequences.locusID = loci.locusID AND loci.locus = ?";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute("$l0$l1") || die "cannot execute the query: $sth->errstr";
	$ID = $sth->fetchall_arrayref() || die "$sth->errstr\n";
	
	
	
	############################### CALCULATE NEW DISTANCES AND UPLOAD
	for($k = 0; $k < $#{$ID}; $k++){
		
		$kSequenceID = $ID->[$k][0];
		$kSequence0ID = $ID->[$k][1];
		$kSequence1ID = $ID->[$k][2];
		
		for($j = $k+1; $j <= $#{$ID}; $j++){
			
			$jSequenceID = $ID->[$j][0];
			$jSequence0ID = $ID->[$j][1];
			$jSequence1ID = $ID->[$j][2];
			
			$difference0 = 0;
			$bases0 = 0;
			$difference1 = 0;
			$bases1 = 0;
											
			if(($kSequence0ID ne "") && ($jSequence0ID ne "")){ ############################### QUERY LOCUS 0
				$query = "SELECT pDifference, pBases
					  FROM $l0
					  WHERE (($l0.sequence0ID = ? AND $l0.sequence1ID = ?) OR ($l0.sequence0ID = ? AND $l0.sequence1ID = ?))";
				$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
				$rv = $sth->execute($kSequence0ID, $jSequence0ID, $jSequence0ID, $kSequence0ID) || die "cannot execute the query: $sth->errstr";
				$distance = $sth->fetchall_arrayref() || die "$sth->errstr\n";
				
				$difference0 = $distance->[0][0];
				$bases0 = $distance->[0][1];
				}
			
			if(($kSequence1ID ne "") && ($jSequence1ID ne "")){ ############################### QUERY LOCUS 1
				$query = "SELECT pDifference, pBases
					  FROM $l1
					  WHERE (($l1.sequence0ID = ? AND $l1.sequence1ID = ?) OR ($l1.sequence0ID = ? AND $l1.sequence1ID = ?))";
				$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
				$rv = $sth->execute($kSequence1ID, $jSequence1ID, $jSequence1ID, $kSequence1ID) || die "cannot execute the query: $sth->errstr";
				$distance = $sth->fetchall_arrayref() || die "$sth->errstr\n";
				
				$difference1 = $distance->[0][0];
				$bases1 = $distance->[0][1];
				}
				
				
				
			############################### CALCULATE
			if(($bases0 == 0) || ($bases1 == 0)){ ############################### INCOMPLETE OR NO OVERLAP
				if(($bases0 == 0) && ($bases1 == 0)){ ############################### INCOMPLETE OVERLAP
					$p = 0;
					} else {
						$p = int(1000000*(($difference0 + $difference1)/($bases0 + $bases1)));
						}
				$overlap = "no";
				} else { ############################### TOTAL OVERLAP
					$p = int(1000000*(($difference0 + $difference1)/($bases0 + $bases1)));
					$overlap = "yes";
					}
			
			
			
			############################### UPLOAD
			$query = "INSERT INTO $l0$l1 SET sequence0ID = ?, sequence1ID = ?, overlapping = ?, p = ?, pDifference = ?, pBases = ?
				  ON DUPLICATE KEY UPDATE  overlapping = ?, p = ?, pDifference = ?, pBases = ?";
			$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
			$rv = $sth->execute($kSequenceID, $jSequenceID, $overlap, $p, ($difference0 + $difference1), ($bases0 + $bases1), $overlap, $p, ($difference0 + $difference1), ($bases0 + $bases1)) || die "cannot execute the query: $sth->errstr";
			}
		}
		
		
		
	############################### CLEAN UP
	$rc = $sth->finish;
	$sql->disconnect;
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script to combine two loci into a single locus\n");
		print("using stored distance calculations.\n\n");
		print("USAGE:\taggregate.pl -0 locus -1 locus\n\n");
		}
		
		
		
exit;
