#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$l = ();
$d = "p";
$go = 0;



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-l"){
		$l = $ARGV[$k+1];
		$go++;
		}
	}



if($go == 1){ ############################### INPUT GIVEN
	
	
	
	############################### DATABASE CONNECTION
	use DBI;
	my $database = "markers";
	my $host = "localhost";
	my $id = "realBOLD";
	my $password = "realBOLD";
	my $sql = DBI->connect("DBI:mysql:$database:$host",$id,$password);
	if(!defined $sql) { 
		die "Cannot connect: $DBI::errstr \n";
		}
	
	
	
	############################### R CONNECTION
	use Statistics::R;
	my $R = Statistics::R->new();
	$R->startR;
		
		
		
	############################### GENERA, SPECIES, AND CONFUSION
	$query = "CREATE TEMPORARY TABLE aaa (
		  SELECT DISTINCT 0genus AS genus, 0species AS species, 1genus AS confusableGenus, 1species AS confusableSpecies, 0ID AS taxonID, overlapping 
		  FROM (SELECT taxa0.taxonID AS 0ID, taxa0.genus AS 0genus, taxa0.species AS 0species, $l.sequence0ID, $l.sequence1ID, taxa1.taxonID AS 1ID, taxa1.genus AS 1genus, taxa1.species 1species, $l.$d, overlapping
		  	FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1 
			WHERE
			    $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID
			AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID
			AND loci0.locus = ? AND $l.$d = 0 GROUP BY CONCAT($l.sequence0ID, ' ', $l.sequence1ID) ORDER BY taxa0.genus, taxa0.species) AS zzz 
		  WHERE CONCAT(0genus, ' ', 0species) != CONCAT(1genus, ' ', 1species))
		  UNION (
		  SELECT DISTINCT 1genus, 1species, 0genus, 0species, 1ID, overlapping 
		  FROM (SELECT taxa0.taxonID AS 0ID, taxa0.genus AS 0genus, taxa0.species AS 0species, $l.sequence0ID, $l.sequence1ID, taxa1.taxonID AS 1ID, taxa1.genus AS 1genus, taxa1.species 1species, $l.$d, overlapping
		  	FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1 
			WHERE
			    $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID
			AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID
			AND loci0.locus = ? AND $l.$d = 0 GROUP BY CONCAT($l.sequence0ID, ' ', $l.sequence1ID) ORDER BY taxa0.genus, taxa0.species) AS zzz 
		   WHERE CONCAT(0genus, ' ', 0species) != CONCAT(1genus, ' ', 1species))";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l, $l) || die "cannot execute the query: $sth->errstr";
	
	$query = "CREATE TEMPORARY TABLE bbb 
		  SELECT DISTINCT taxa.taxonID, taxa.clade, taxa.genus, taxa.species, yyy.sequencedSP 
		  FROM taxa, specimens, sequences, loci, (SELECT xxx.genus, COUNT(DISTINCT xxx.species) AS sequencedSP 
		  					  FROM (SELECT clade, genus, species 
							  	FROM taxa, specimens, sequences, loci 
								WHERE taxa.taxonID = specimens.taxonID AND specimens.specimenID = sequences.specimenID AND sequences.locusID = loci.locusID 
								AND locus = ? ORDER BY clade, genus) AS xxx 
								GROUP BY xxx.genus ORDER BY xxx.clade, xxx.genus) AS yyy 
		  WHERE taxa.taxonID = specimens.taxonID AND specimens.specimenID = sequences.specimenID AND sequences.locusID = loci.locusID AND yyy.genus = taxa.genus 
		  AND locus = ? ORDER BY clade, genus, species";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l, $l) || die "cannot execute the query: $sth->errstr";
	
	$query = "CREATE TEMPORARY TABLE ccc 
		  SELECT taxa.taxonID, clade, genus, species, COUNT(sequences.sequenceID) AS seq 
		  FROM taxa, specimens, sequences, loci 
		  WHERE taxa.taxonID = specimens.taxonID AND specimens.specimenID = sequences.specimenID AND sequences.locusID = loci.locusID 
		  AND locus = ? GROUP BY taxonID";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l) || die "cannot execute the query: $sth->errstr";
	
	$query = "SELECT bbb.clade, bbb.genus, bbb.species, bbb.sequencedSP, ccc.seq, CONCAT(aaa.confusableGenus, ' ', aaa.confusableSpecies), aaa.overlapping
	          FROM bbb JOIN ccc ON (bbb.taxonID = ccc.taxonID)
		  LEFT JOIN aaa ON (aaa.taxonID = bbb.taxonID)
		  ORDER BY bbb.clade, bbb.genus, bbb.species, aaa.confusableGenus, aaa.confusableSpecies";

### TESTING RINGER		  
#$query = "SELECT bbb.clade, bbb.genus, bbb.species, bbb.sequencedSP, ccc.seq, CONCAT(aaa.confusableGenus, ' ', aaa.confusableSpecies), aaa.overlapping FROM bbb JOIN ccc ON (bbb.taxonID = ccc.taxonID) LEFT JOIN aaa ON (aaa.taxonID = bbb.taxonID) ORDER BY bbb.clade, bbb.genus, bbb.species, aaa.confusableGenus, aaa.confusableSpecies LIMIT 100";	  
### TESTING RINGER

	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute() || die "cannot execute the query: $sth->errstr";
	$taxa = $sth->fetchall_arrayref() || die "$sth->errstr\n";
	
	
	
	############################### RESULTS
	$buffer  = "clade,genus,species,sequences,overlapping markers for indistinct species";

	$buffer .= ",one species: one sequence: indistinct";
	$buffer .= ",one species: one sequence: distinct";
	$buffer .= ",one species: multiple sequences: indistinct";
	$buffer .= ",one species: multiple sequences: distinct (grouped)";
	$buffer .= ",one species: multiple sequences: distinct (ungrouped)";
	
	$buffer .= ",multiple species: one sequence: indistinct";
	$buffer .= ",multiple species: one sequence: distinct";
	$buffer .= ",multiple species: multiple sequences: indistinct";
	$buffer .= ",multiple species: multiple sequences: distinct (grouped)";
	$buffer .= ",multiple species: multiple sequences: distinct (ungrouped)";
	
	$buffer .= ",indistinguishable,indistinguishable from,nearest to\n";

	$clade = ();
	$genus = ();
	$species = ();
	$spp = ();
	$seq = ();	
	$confusable = ();
	$confused = ();
	$overlap = ();
	$overlapping = ();
	$close = ();
	$lastClade = ();
	$lastGenus = ();
	$lastSpecies = ();
	$lastSeq = ();
	$result = ();
	$resultsClade = ();
	$resultsCladeFull = ();
	$resultsTotal = ();
	$resultsTotalFull = ();
	
	for($k = 0; $k <= $#{$taxa}; $k++){
		
		$clade = $taxa->[$k][0];
		$genus = $taxa->[$k][1];
		$species = $taxa->[$k][2];
		$spp = $taxa->[$k][3];
		$seq = $taxa->[$k][4];
		$confused = $taxa->[$k][5];
		$overlap = $taxa->[$k][6];
		
		if(($genus ne $lastGenus) || ($species ne $lastSpecies)){
			
			############################### FINISH PREVIOUS
			if($k != 0){
				if($confusable ne ""){
					$count = 1;
					$count++ while($confusable =~ m/\*/g);
					$buffer .= "$lastClade,$lastGenus,$lastSpecies,$lastSeq,$overlapping,$result,$count,*$confusable*,---\n";
					$resultsClade .= "1,$result,$count|";
					$resultsTotal .= "1,$result,$count|";
					if($overlapping ne "no"){
						$resultsCladeFull .= "1,$result,$count|";
						$resultsTotalFull .= "1,$result,$count|";
						} else {
							$resultsCladeFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
							$resultsTotalFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
							}
					} else {
						$buffer .= "$lastClade,$lastGenus,$lastSpecies,$lastSeq,$overlapping,$result,0,nothing,*$close*\n";
						$resultsClade .= "1,$result,0|";
						$resultsTotal .= "1,$result,0|";
						if($overlapping ne "no"){
							$resultsCladeFull .= "1,$result,0|";
							$resultsTotalFull .= "1,$result,0|";
							} else {
								$resultsCladeFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
								$resultsTotalFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
								}
						}		
				}
			$result = ();	
			$confusable = $confused;
			if($overlap eq ""){
				$overlapping = "---";
				} else {
					$overlapping = $overlap;
					}
			$close = ();
			
			if(($clade ne $lastClade) && ($k != 0)){
				$buffer .= total($lastClade, "subtotal", $resultsClade);
				$buffer .= total($lastClade, "subtotal---complete comparisons & distinct comparisons only", $resultsCladeFull);
				$resultsClade = ();
				$resultsCladeFull = ();
				}
				
			if($spp == 1){ ############################### SINGLE SPECIES PER GENUS
				if($seq == 1){ ############################### SINGLE SEQUENCE
					if($confused eq ""){ ############################### SINGLE SEQUENCE DISTINCT
						$result = "0,1,---,---,---";
						$close = near($genus, $species);
						} else { ############################### SINGLE SEQUENCE INDISTINCT
							$result = "1,0,---,---,---";
							$close = "---";		
							}
							
					} else { ############################### MULTIPLE SEQUENCE
						if($confused eq ""){ ############################### MULTIPLE SEQUENCE DISTINCT
							$intraspecific = intra($genus, $species);
							if($intraspecific == 0){ ############################### MULTIPLE SEQUENCE DISTINCT (GROUPED)
								$result = "---,---,0,1,0";
								$close = near($genus, $species);		
								} else {
									$interspecific = inter($genus, $species);
									if($intraspecific < $interspecific){  ############################### MULTIPLE SEQUENCE DISTINCT (GROUPED)
										$result = "---,---,0,1,0";
										$close = near($genus, $species);		
									 	} else {  ############################### MULTIPLE SEQUENCE DISTINCT (UNGROUPED)
											$result = "---,---,0,0,1";
											$close = near($genus, $species);		
											}
									}
							} else { ############################### MULTIPLE SEQUENCE INDISTINCT
								$result = "---,---,1,0,0";
								$close = "---";		
								}
						}
				$result .= ",---,---,---,---,---";
				} else { ############################### MULTIPLE SPECIES PER GENUS
				 	$result = "---,---,---,---,---";
					if($seq == 1){ ############################### SINGLE SEQUENCE
						if($confused eq ""){ ############################### SINGLE SEQUENCE DISTINCT	
							$result .= ",0,1,---,---,---";
							$close = near($genus, $species);		
							} else { ############################### SINGLE SEQUENCE INDISTINCT
								$result .= ",1,0,---,---,---";
								$close = "---";
								}
						} else { ############################### MULTIPLE SEQUENCE
							if($confused eq ""){ ############################### MULTIPLE SEQUENCE DISTINCT
								$intraspecific = intra($genus, $species);
								if($intraspecific == 0){ ############################### MULTIPLE SEQUENCE DISTINCT (GROUPED)
									$result .= ",---,---,0,1,0";
									$close = near($genus, $species);		
									} else {
										$interspecific = inter($genus, $species);
										 if($intraspecific < $interspecific){  ############################### MULTIPLE SEQUENCE DISTINCT (GROUPED)
											$result .= ",---,---,0,1,0";
											$close = near($genus, $species);		
											} else {  ############################### MULTIPLE SEQUENCE DISTINCT (UNGROUPED)
												$result .= ",---,---,0,0,1";
												$close = near($genus, $species);		
												}
										}
								} else { ############################### MULTIPLE SEQUENCE INDISTINCT
									$result .= ",---,---,1,0,0";
									$close = "---";		
									}
							}
					}
			} else { ############################### ADD TO CONFUSABLE UNTIL END OF SPECIES								
				$confusable .= "*$confused";
				if($overlapping ne "no"){
					$overlapping = $overlap;
					}
				}
		
		$lastClade = $clade;
		$lastGenus = $genus;
		$lastSpecies = $species;
		$lastSeq = $seq;
		
		if(length($buffer) > 10000){
			print("$buffer");
			$buffer = ();
			}		
		}
	
	
	
	############################### FINISH LAST LINE OF TABLE
	if($confusable ne ""){
	$count = 1;
	$count++ while($confusable =~ m/\*/g);
	$buffer .= "$lastClade,$lastGenus,$lastSpecies,$lastSeq,$overlapping,$result,$count,*$confusable*,---\n";
	$resultsClade .= "1,$result,$count|";
	$resultsTotal .= "1,$result,$count|";
	if($overlapping ne "no"){
		$resultsCladeFull .= "1,$result,$count|";
		$resultsTotalFull .= "1,$result,$count|";
		} else {
			$resultsCladeFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
			$resultsTotalFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
			}
	} else {
		$buffer .= "$lastClade,$lastGenus,$lastSpecies,$lastSeq,$overlapping,$result,0,nothing,*$close*\n";
		$resultsClade .= "1,$result,0|";
		$resultsTotal .= "1,$result,0|";
		if($overlapping ne "no"){
			$resultsCladeFull .= "1,$result,0|";
			$resultsTotalFull .= "1,$result,0|";
			} else {
				$resultsCladeFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
				$resultsTotalFull .= "0,---,---,---,---,---,---,---,---,---,---,---|";
				}
		}		
			
			

	############################### LAST SUBTOTAL AND GRAND TOTAL
	$buffer .= total($lastClade, "subtotal", $resultsClade);
	$buffer .= total($lastClade, "subtotal---complete comparisons & distinct comparisons only", $resultsCladeFull);
	$buffer .= total("all", "grand total", $resultsTotal);
	$buffer .= total("all", "grand total---complete comparisons & distinct comparisons only", $resultsTotalFull);
	print("$buffer");
	
	
	
	############################### CLEAN UP
	$rc = $sth->finish;
	$sql->disconnect;
	$R->stopR();
	
	
	
	############################### FIND NEAR SPECIES
	sub near(){
		my $genus = $_[0];
		my $species = $_[1];
		
		my $query = "SELECT taxa0.genus, taxa0.species, taxa1.genus, taxa1.species
			     FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1  
			     WHERE
			         $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID 
			     AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID 
			     AND loci0.locus = ? AND (((taxa0.genus = ? AND taxa0.species = ?) AND NOT (taxa1.genus = ? AND taxa1.species = ?)) 
			     OR ((taxa1.genus = ? AND taxa1.species = ?) AND NOT (taxa0.genus = ? AND taxa0.species = ?)))
			     AND $l.$d = (SELECT MIN($l.$d) 
				     	         FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1  
					         WHERE
					             $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID 
					         AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID 
					         AND loci0.locus = ? AND (((taxa0.genus = ? AND taxa0.species = ?) AND NOT (taxa1.genus = ? AND taxa1.species = ?)) 
			                         OR ((taxa1.genus = ? AND taxa1.species = ?) AND NOT (taxa0.genus = ? AND taxa0.species = ?))))";
		 my $sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
		 my $rv = $sth->execute($l, $genus, $species, $genus, $species, $genus, $species, $genus, $species, $l, $genus, $species, $genus, $species, $genus, $species, $genus, $species) || die "cannot execute the query: $sth->errstr";
		 my $list = $sth->fetchall_arrayref() || die "$sth->errstr\n";
		 my @taxa = ();
		 for(my $j = 0; $j <= $#{$list}; $j++){
			 if(($list->[$j][0] eq $genus) && ($list->[$j][1] eq $species)){
				$taxa[$j] = $list->[$j][2] . " " . $list->[$j][3];
				} else {
					$taxa[$j] = $list->[$j][0] . " " . $list->[$j][1];
					}
			}
		 my %unique = ();
		 $unique{$_}++ for(@taxa);
		 @taxa = keys(%unique);
		 @taxa = sort(@taxa);
		 return(join('*', @taxa));					
		}
	
	
	
	############################### INTRASPECIFIC DISTANCE
	sub intra(){
		my $genus = $_[0];
		my $species = $_[1];
		my $query = "SELECT MAX($l.$d) 
                             FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1  
		             WHERE
		                 $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID 
		             AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID 
		             AND loci0.locus = ? 
		             AND ((taxa0.genus = ? AND taxa0.species = ?) AND (taxa1.genus = ? AND taxa1.species = ?))";
		my $sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
		my $rv = $sth->execute($l, $genus, $species, $genus, $species) || die "cannot execute the query: $sth->errstr";
		my $intraspecific = $sth->fetchall_arrayref() || die "$sth->errstr\n";
		
		return($intraspecific->[0][0]);		  
		}
		
		
		
	############################### INTERSPECIFIC DISTANCE	
	sub inter(){
		my $genus = $_[0];
		my $species = $_[1];
		my $query = "SELECT MIN($l.$d) 
			     FROM $l, sequences AS sequences0, sequences AS sequences1, specimens AS specimens0, specimens AS specimens1, taxa AS taxa0, taxa AS taxa1, loci AS loci0, loci AS loci1  
			     WHERE
			         $l.sequence0ID = sequences0.sequenceID AND sequences0.specimenID = specimens0.specimenID AND specimens0.taxonID = taxa0.taxonID AND sequences0.locusID = loci0.locusID 
			     AND $l.sequence1ID = sequences1.sequenceID AND sequences1.specimenID = specimens1.specimenID AND specimens1.taxonID = taxa1.taxonID AND sequences1.locusID = loci1.locusID 
			     AND loci0.locus = ? AND (((taxa0.genus = ? AND taxa0.species = ?) AND NOT (taxa1.genus = ? AND taxa1.species = ?)) 
			     OR ((taxa1.genus = ? AND taxa1.species = ?) AND NOT (taxa0.genus = ? AND taxa0.species = ?)))";
		my $sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
		my $rv = $sth->execute($l, $genus, $species, $genus, $species, $genus, $species, $genus, $species) || die "cannot execute the query: $sth->errstr";
		my $interspecific = $sth->fetchall_arrayref() || die "$sth->errstr\n";
		
		return($interspecific->[0][0]);
		}
		
		
		
	############################### SUMMARIZE COLUMNS
	sub total(){
		my $lastClade = $_[0];
		my $total = $_[1];
		my $junk = $_[2];
		
		############################### BUILD TABLE
		my @rawResults = split(/\|/, $junk);
		my $results;
		for(my $k = 0; $k <= $#rawResults; $k++){
			my @row = split(/,/, $rawResults[$k]);
			for(my $i = 0; $i <= $#row; $i++){
				$results->[$k][$i] = $row[$i];
				}
			}
		
		############################### CALCULATE SUMS
		my @totals = ();
		for(my $i = 0; $i < $#{$results->[0]}; $i++){
			$totals[$i] = 0;
			for(my $k = 0; $k <= $#{$results}; $k++){
				if($results->[$k][$i] eq "1"){
					$totals[$i]++;
					}
				}
			}
		
		my $final = "$lastClade,$total,,";
		for(my $k = 0; $k <= 10; $k++){
			$final .= "," . $totals[$k];
			}
		
		############################### MEAN ETC FROM R
		my @confused = ();
		for(my $k = 0; $k <= $#{$results}; $k++){
			if($results->[$k][$#{$results->[0]}] != 0){
				push(@confused, $results->[$k][$#{$results->[0]}]);
				}
			}
		
		if($#confused >= 1){
			my $data = "c(" . join(",", @confused) . ")";	
			$R->send(qq`x <- $data`);
			$R->send(qq`print(mean(x))`);
			$final .= ",mean=" . sprintf('%.3f', fixR($R->read,1));
			$R->send(qq`print(sd(x))`);
			$final .= " sd=" . sprintf('%.3f', fixR($R->read,1));
			$R->send(qq`print(median(x))`);
			$final .= " median=" . fixR($R->read,1);
			$R->send(qq`print(quantile(x, probs = 0.25, type = 3))`);
			my @temp = split(/\n/, $R->read);
			$temp[1] =~ tr/ //d;
			$final .= " IQR=$temp[1]";
			$R->send(qq`print(quantile(x, probs = 0.75, type = 3))`);
			my @temp = split(/\n/, $R->read);
			$temp[1] =~ tr/ //d;
			$final .= "--$temp[1],,\n";
			} else {
				$final .= ",NOT COMPUTED,,\n";
				}
		
		return($final);
		}
	
	
	
	############################### REMOVE BRACKETS FROM R OUTPUT
	sub fixR(){
		my $Rstring = $_[0];
		my $start = $_[1]; #first array element to output
		my @output = split(/ /, $Rstring);
		return(join(' ', @output[$start..$#output]));
		}
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script to output a summary of sequence diversity\n");
		print("ala Hollingsworth's Data Analysis Categories.\n\n");
		print("USAGE:\tdiagnosis.pl -l locus\n");
		print("where\t-l\tis a locus in table `loci`\n\n");
		}
		
		
		
exit;
