#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$l = ();
$go = 0;



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-l"){
		$l = $ARGV[$k+1];
		$l =~ tr/[a-z][A-Z][0-9]//cd;
		if(length($l)){
			$go++;
			}
		}
	}



if($go == 1){ ############################### INPUT GIVEN
	
	
	
	############################### DATABASE CONNECTION
	use DBI;
	my $database = "markers";
	my $host = "localhost";
	my $id = "realBOLD";
	my $password = "realBOLD";
	my $sql = DBI->connect("DBI:mysql:$database:$host",$id,$password);
	if(!defined $sql) { 
		die "Cannot connect: $DBI::errstr \n";
		}
	
	
	
	############################### QUERY
	$query = "SELECT sequences.sequenceID, sequence, collection 
	          FROM bases, sequences, loci, specimens 
		  WHERE bases.sequenceID = sequences.sequenceID AND sequences.locusID = loci.locusID AND sequences.specimenID = specimens.specimenID
		  AND loci.locus = ?";
	$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
	$rv = $sth->execute($l) || die "cannot execute the query: $sth->errstr";
	$data = $sth->fetchall_arrayref() || die "$sth->errstr\n";
	
	$buffer = ();
	for($k = 0; $k <= $#{$data}; $k++){
		$buffer .= prettyPrint($data->[$k][0],$data->[$k][1], $data->[$k][2]);
		if(length($buffer) > 10000){
			print("$buffer");
			$buffer = ();
			}
		}
	print("$buffer");
	
	
	
	############################### WRAP TEXT
	sub prettyPrint($){
		my $ID = $_[0];
		my $SEQ = $_[1];
		my $name = $_[2];
		my @seq = split(//, $SEQ);
		my $buffer = ">$ID";
		for(my $i = 0; $i <= $#seq; $i++){
			if(($i % 80) == 0){
				$buffer .= "\n" . $seq[$i];
				} else {
					$buffer .= $seq[$i];
					}	
			}
		$buffer .= "\n";
		return($buffer);		
		}
	
	
	
	############################### CLEAN UP
	$rc = $sth->finish;
	$sql->disconnect;
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script for downloading FASTA formated sequences from\n");
		print("the tables `loci', `sequences`, and `specimens`.\n");
		print("USAGE: distances-down.pl -l locus\n\n");
		}
		
		
		
exit;
