#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$i = ();
$l = ();
$go = 0;



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-i"){
		$i = $ARGV[$k+1];
		if(-e "$i"){
			$go++;
			}
		}
	if($ARGV[$k] eq "-l"){
		$l = $ARGV[$k+1];
		$go++;
		}	
	}



if($go == 2){ ############################### INPUT GIVEN
	
	
	
	############################### DATABASE CONNECTION
	use DBI;
	my $database = "markers";
	my $host = "localhost";
	my $id = "realBOLD";
	my $password = "realBOLD";
	my $sql = DBI->connect("DBI:mysql:$database:$host",$id,$password);
	if(!defined $sql) { 
		die "Cannot connect: $DBI::errstr \n";
		}
		
		
		
	############################### READ FILE
	open(INFILE, "$i") || die("Could not open $i!");
	$k = 0;
	$j = 0;
	while($line = <INFILE>){
		chomp($line);
		if(length($line)){
			if($k != 0){ ############################### IS DATA
				($sequence0ID, $sequence1ID, $p, $pDifference, $pBases, $sequence0, $sequence1) = split(/,/, $line);
				
				my $query = "INSERT INTO $l SET sequence0ID = ?, sequence1ID = ?, overlapping = 'yes', p = ?, pDifference = ?, pBases = ?
 					     ON DUPLICATE KEY UPDATE  overlapping = 'yes', p = ?, pDifference = ?, pBases = ?";
				$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
				$rv = $sth->execute($sequence0ID, $sequence1ID, $p, $pDifference, $pBases, $p, $pDifference, $pBases) || die "cannot execute the query: $sth->errstr";				
				
				$j++;
				}
			$k++;
			}
		}
	close(INFILE);
	print("$j records uploaded to $l\n");
	
	
	
	############################### CLEAN UP
	$rc = $sth->finish;
	$sql->disconnect;
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script to load distances.pl csv files into `distances` table.\n\n");
		print("USAGE:\tdistances-up.pl -i in-file.csv -l locus\n\n");
		}
		
		
		
exit;
