#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$i = ();
$go = 0;
$infile = "temporary-in-do-not-touch";
$outfile = "temporary-out-do-not-touch";



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-i"){
		$i = $ARGV[$k+1];
		if(-e "$i"){
			$go++;
			}
		}
	}



if($go == 1){ ############################### INPUT GIVEN
	
	
	
	############################### READ SEQUENCES
	open(INFILE, "$i") || die("Could not open $i!");
	@ID = ();
	@SEQUENCES = ();
	$seq = ();
	$name =();
	$k = 0;
	while($line = <INFILE>){
		chomp($line);
		if(length($line)){
			if($line =~ m/^>/){ ############################### IS NAME
				if(length($name) && length($seq)){
					$name =~ tr/[0-9]//cd;
					$ID[$k] = $name;
					uc($seq);
					$seq =~ tr/ACGTNVDBHWMRKSY//cd;
					$SEQUENCE[$k] = $seq;
					$k++;
					}
				$seq = ();
				$name = $line;
				} else { ############################### IS NOT NAME
					$seq .= $line;
					}
			}
		}
	close(INFILE);
	$name =~ tr/[0-9]//cd;
	$ID[$k] = $name;
	$seq =~ tr/ACGTNVDBHWMRKSY//cd;
	$SEQUENCE[$k] = $seq;
	
	
	
	############################### ALIGN AND PROCESS SEQUENCES
	$buffer = "sequence0ID,sequence1ID,p,p-differences,p-bases,sequence0,sequence1\n";
	$bufferK = ();
	$bufferJ = ();
	for($k = 0; $k < $#ID; $k++){
		
		$bufferK = prettyPrint($ID[$k],$SEQUENCE[$k]);
		
		for($j = $k+1; $j <= $#ID; $j++){
			
			$bufferJ = prettyPrint($ID[$j],$SEQUENCE[$j]);
			
			open(OUTFILE, ">$infile") || die("Could not open $infile file!");
			print OUTFILE "$bufferK\n$bufferJ\n";
			close(OUTFILE);
	
			qx/muscle -stable -in $infile -out $outfile/;
			unlink($infile);
			
			open(INFILE, "$outfile") || die("Could not open $outfile file!");
			@sequence = ();
			$i = 0;
			while($line = <INFILE>){
				chomp($line);
				if(length($line)){
					if($line =~ m/^>/){ ############################### IS NAME
						if(length($sequence[$i])){
							uc($sequence[$i]);
							$sequence[$i] =~ tr/ACGTNVDBHWMRKSY-//cd;
							$i++;
							}
						$sequence[$i] = ();
						} else { ############################### IS NOT NAME
							$sequence[$i] .= $line;
							}
					}
				}
			close(INFILE);
			unlink($outfile);
			uc($sequence[$i]);
			$sequence[$i] =~ tr/ACGTNVDBHWMRKSY-//cd;
			
			$buffer .= "$ID[$k],$ID[$j]," . pDIST($sequence[0],$sequence[1])  . ",$sequence[0],$sequence[1]\n";
			
			if(length($buffer) > 10000){
				print("$buffer");
				$buffer = ();
				}
			}
		}
	print("$buffer");
	
	
	
	############################### WRAP TEXT
	sub prettyPrint($){
		my $ID = $_[0];
		my $SEQ = $_[1];
		my @seq = split(//, $SEQ);
		my $buffer = ">$ID";
		for(my $i = 0; $i <= $#seq; $i++){
			if(($i % 80) == 0){
				$buffer .= "\n" . $seq[$i];
				} else {
					$buffer .= $seq[$i];
					}	
			}
		$buffer .= "\n";
		return($buffer);		
		}
	
	
	
	############################### P DISTANCE + JC69 + K2P
	sub pDIST($){
		my $SEQ0 = $_[0];
		my $SEQ1 = $_[1];
		
		my @seq0 = split(//, $SEQ0);
		my @seq1 = split(//, $SEQ1);
		
		my $bases = 0;
		my $difference = 0;

		for(my $k = 0; $k <= $#seq0; $k++){
			my $pair = $seq0[$k] . $seq1[$k];
			if(!($pair =~ m/-|N/)){
				if($seq0[$k] ne $seq1[$k]){
					if($pair =~ m/V|D|B|H|W|M|R|K|S|Y/){ ############################### POLYMO
						if(($pair =~ m/R/) && ($pair =~ m/C|T|Y/)){
							$difference++;
							}
						if(($pair =~ m/Y/) && ($pair =~ m/A|G|R/)){
							$difference++;
							}
						if(($pair =~ m/M/) && ($pair =~ m/G|T|K/)){
							$difference++;
							}
						if(($pair =~ m/K/) && ($pair =~ m/C|A|M/)){
							$difference++;
							}	
						if(($pair =~ m/S/) && ($pair =~ m/A|T|W/)){
							$difference++;
							}
						if(($pair =~ m/W/) && ($pair =~ m/C|G|S/)){
							$difference++;
							}
						if(($pair =~ m/H/) && ($pair =~ m/G/)){
							$difference++;
							}
						if(($pair =~ m/B/) && ($pair =~ m/A/)){
							$difference++;
							}
						if(($pair =~ m/V/) && ($pair =~ m/T/)){
							$difference++;
							}
						if(($pair =~ m/D/) && ($pair =~ m/C/)){
							$difference++;
							}	
						} else { ############################### NO POLYMO
							$difference++;		
							}
					}
				$bases++;
				}
			}
		
		my $p = int(1000000*($difference/$bases));
		
		return("$p,$difference,$bases");
		}	
		
		
		
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script converts FASTA sequences to a csv file of\n");
		print("pair-wise alignments and distances. MUSCLE is required.\n");
		print("Names should consist of sequenceID only.\n\n");
		print("USAGE: distances.pl -i in-file.fasta\n\n");
		}
		
		
		
exit;
