#!/usr/bin/perl

############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2009 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
$i = ();
$go = 0;



for($k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-i"){
		$i = $ARGV[$k+1];
		if(-e "$i"){
			$go++;
			}
		}
	}



if($go == 1){ ############################### INPUT GIVEN
	
	
	
	############################### DATABASE CONNECTION
	use DBI;
	my $database = "markers";
	my $host = "localhost";
	my $id = "realBOLD";
	my $password = "realBOLD";
	my $sql = DBI->connect("DBI:mysql:$database:$host",$id,$password);
	if(!defined $sql) { 
		die "Cannot connect: $DBI::errstr \n";
		}
	
	
	
	############################### READ AND UPLOAD TAXA
	open(INFILE, "$i") || die("Could not open $i!");
	$count = 0;
	while($line = <INFILE>){
		chomp($line);
		if(length($line)){
			$line =~ tr/[a-z][A-Z][0-9],//cd;
			@bits = split(/,/, $line);
			$query = "INSERT INTO taxa SET clade = ?, genus = ?, species = ? ON DUPLICATE KEY UPDATE clade = ?, genus = ?, species = ?";
			$sth = $sql->prepare($query) || die "cannot prepare $statement: $sql->errstr\n";
			$rv = $sth->execute($bits[0], $bits[1], $bits[2], $bits[0], $bits[1], $bits[2]) || die "cannot execute the query: $sth->errstr";
			$count++;
			}
		}
	close(INFILE);
	print("$count records uploaded\n\n");
	
	
	
	############################### CLEAN UP
	$rc = $sth->finish;
	$sql->disconnect;
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script for loading csv taxon lists into the `taxa`\n");
		print("table in the form of `clade,genus,species`.\n\n");
		print("USAGE: taxa.pl -i in-file.csv\n\n");
		}
		
		
		
exit;
